'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'<t>    Get requested directory entries


'       This file may be distributed freely, as long as no money is charged
'       for it, and all files are included AS THEY ARE!
'
'       Since you're not paying for the source code, don't expect support.
'       (Unless you're willing to pay for that of course!)


'       The variable ENTRY$ contains the filespec for the directory search.
'       A path name may be included.
'       CURR.DIR$ must contain the current directory.


        DIM DIREC.TBL(50)


DIREC.SUB:
        BY.PASSED=0: FIRST.SCRN=TRUE: DIREC.SELECTED=FALSE: DIR.BYTES# = -1
        IF CURR.DIR$="" THEN _
          COLOR 7,0,0: PRINT: _
          PRINT "INTERNAL ERROR: No current directory found.": PRINT "Please report!": STOP
        IF ENTRY$="" OR ENTRY$="*" THEN ENTRY$=CURR.DRIVE$+"*.*"
        IF LEN(ENTRY$)=1 THEN ENTRY$=CURR.DRIVE$+ENTRY$

'       Split ENTRY$ into drive, path, and filename

        IF MID$(ENTRY$,2,1)=":" THEN _
          EN.DRIVE$=MID$(ENTRY$,1,2): ENTRY$=MID$(ENTRY$,3) _
        ELSE _
          EN.DRIVE$=""
        GOSUB DIREC.SPLIT.PATH
        IF EN.FSPEC$="" THEN EN.FSPEC$="*.*"


        OPEN "$$TMP$$.BAT" FOR OUTPUT AS #1
        PRINT #1, "echo off"
        IF CL.SCREEN THEN PRINT #1, "cls"
        PRINT #1, "echo  Wait please.  Creating directory for:"
        PRINT #1, "echo                Drive ........ ";EN.DRIVE$
        PRINT #1, "echo                Path ......... ";EN.PATH$
        PRINT #1, "echo                File specs ... ";EN.FSPEC$
        IF EN.DRIVE$<>"" THEN PRINT #1, EN.DRIVE$
        IF EN.PATH$ <>"" THEN PRINT #1, "cd "+EN.PATH$
        PRINT #1, "DIR "+EN.FSPEC$+" >"+CURR.DRIVE$+CURR.PATH$+"$$DIR$$.TMP"
        PRINT #1, CURR.DRIVE$
        PRINT #1, "cd "+CURR.DIR$
        CLOSE 1
        SHELL "$$TMP$$"
        KILL "$$TMP$$.BAT"
        OPEN "$$DIR$$.TMP" FOR INPUT AS #1
        REC.CNT=0


DIREC.READ.LOOP:
        IF EOF(1) THEN GOTO DIREC.READ.QUIT
        LINE INPUT #1, REC$
        IF REC$ = "" THEN GOTO DIREC.READ.DONE
        IF MID$(REC$,10,5) = " file"        THEN GOTO DIREC.READ.DONE
        IF MID$(REC$,13,9) = " <DIR>   "    THEN GOTO DIREC.READ.DONE
        IF RIGHT$(REC$,11) = " bytes free"  THEN DIR.BYTES# = (BY.PASSED*1024#)+VAL(MID$(REC$,18)): GOTO DIREC.READ.DONE
        IF LEFT$(REC$,11)  = " Directory "  THEN GOTO DIREC.DIRECTORY
        IF LEFT$(REC$, 8)  = " Volume "     THEN VOL.LAB$ = MID$(REC$,23): GOTO DIREC.READ.DONE
        IF LEFT$(REC$, 1)  = "."            THEN GOTO DIREC.READ.DONE
        IF LEFT$(REC$,12)  = "$$DIR$$  TMP" THEN BY.PASSED=BY.PASSED+1: GOTO DIREC.READ.DONE
        IF LEFT$(REC$,12)  = "$$TMP$$  BAT" THEN BY.PASSED=BY.PASSED+1: GOTO DIREC.READ.DONE
        REC.CNT=REC.CNT+1: IF REC.CNT>MAX.DIREC.ENTRIES THEN GOTO DIREC.READ.DONE
        DIREC.ENTRY$(REC.CNT) = LEFT$(REC$+STRING$(46," "),46)
        ENTRY$= MID$(REC$,27,3)+MT$(VAL(MID$(REC$,24,2)))+MID$(REC$,29,3)
        MID$(DIREC.ENTRY$(REC.CNT),24) = ENTRY$
        DIREC.SELEC(REC.CNT) = FALSE
DIREC.READ.DONE:
        GOTO DIREC.READ.LOOP


DIREC.READ.QUIT:
        CLOSE 1
        KILL "$$DIR$$.TMP"
        DIR.NO.FILES = REC.CNT
        IF (DIR.NO.FILES < 1) or (DIR.BYTES# < 0) THEN _
          LINE.3$ = " " _
        ELSE _
          LINE.3$ = MID$(STR$(DIR.BYTES#),2)+ " bytes available  "
        IF DIR.NO.FILES < 1 THEN ENTRY$ = "  no files found"
        IF DIR.NO.FILES = 1 THEN ENTRY$ = "  1 file"
        IF DIR.NO.FILES > 1 THEN ENTRY$ = " "+ STR$(DIR.NO.FILES)+ " files"
        GOSUB CENTER.LINE
        LINE.A$ = LEFT$("  Volume "+VOL.LAB$+ STRING$(40," "),START.COL-3)+ENTRY$
        LINE.A$ = LINE.A$+ STRING$(78-(LEN(LINE.A$)+LEN(LINE.3$))," ")+LINE.3$
        LINE.1$ = LEFT$("Volume "+VOL.LAB$+ STRING$(32," ")+ ENTRY$+ STRING$(70," "),78)
        LINE.2$ = LEFT$("Drive  "+ DRV.NAM$+"          Directory "+ DIR.NAM$+ STRING$(70," "),78)
        LINE.B$ = "Path: "+ DRV.NAM$+ DIR.NAM$
        LINE.3$ = LEFT$(LINE.3$+ STRING$(80," "),78)
        GOSUB DIREC.SORT
        IF DIR.NO.FILES > 0 THEN _
          DIREC.ENTRY$(1) = DIREC.ENTRY$(1)+"   Top of Directory "
        IF DIR.NO.FILES > 0 THEN _
          DIREC.ENTRY$(DIR.NO.FILES) = LEFT$(DIREC.ENTRY$(DIR.NO.FILES),46)+"   End of Directory "
        RETURN


DIREC.DIRECTORY:
        DRV.NAM$= MID$(REC$,16,2): ENTRY$= MID$(REC$,18): GOSUB MAKE.UPPER: GOSUB STRIP.BLANKS
        REAL.DIR.NAM$= ENTRY$: DIR.NAM$= ENTRY$: IF DIR.NAM$="\" THEN DIR.NAM$="<<root-directory>>"
        GOTO DIREC.READ.DONE


DIREC.SORT:
        MAXSLOT=REC.CNT : IF MAXSLOT<=1 THEN RETURN
        DIREC.ENTRY$(0)=STRING$(40,1)
        DIREC.TBL(1)=1 : STAGE=1
DIREC.SORT.REPEAT:
          DIREC.TBL(STAGE+1)=(3*DIREC.TBL(STAGE))+1 : STAGE=STAGE+1
        IF NOT ((2*DIREC.TBL(STAGE))>=MAXSLOT) THEN GOTO DIREC.SORT.REPEAT
        MAXSTAGE=STAGE-1
        FOR STAGE=MAXSTAGE TO 1 STEP -1
          INTERVAL=DIREC.TBL(STAGE)
          FOR START=1 TO INTERVAL
            FOR I=(START+INTERVAL) TO MAXSLOT STEP INTERVAL
                HOLDI=I
                WHILE DIREC.ENTRY$(I)<DIREC.ENTRY$(I-INTERVAL)
                  SWAP DIREC.ENTRY$(I),DIREC.ENTRY$(I-INTERVAL)
                  IF I-INTERVAL>INTERVAL THEN I=I-INTERVAL
                WEND
                I=HOLDI
            NEXT I
          NEXT START
        NEXT STAGE
        RETURN


DIREC.SPLIT.PATH:
        EN.PATH$="": EN.FSPEC$="": IF LEN(ENTRY$)=0 THEN RETURN
        IF INSTR(ENTRY$,"\")=0 THEN EN.FSPEC$=ENTRY$: RETURN
        EN.PATH$=ENTRY$: IF RIGHT$(EN.PATH$,1)="\" THEN EN.FSPEC$="*.*": RETURN
DIREC.SP.LOOP:
        IF RIGHT$(EN.PATH$,1)="\" THEN _
          EN.PATH$=LEFT$(EN.PATH$,LEN(EN.PATH$)-1): RETURN _
        ELSE _
          EN.FSPEC$=RIGHT$(EN.PATH$,1)+EN.FSPEC$: EN.PATH$=LEFT$(EN.PATH$,LEN(EN.PATH$)-1)
        GOTO DIREC.SP.LOOP
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
