'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $subtitle:  'WINDOW.INC: Screen Window Management Routines'


'       WINDOW.FUNC     Function:                 6 = scroll up
'                                                 7 = scroll down
'       WINDOW.NUM.ROWS Number of rows to scroll  0 to (W.LR.ROW-W.UL.ROW)
'                                                 (0 clears the window)
'       W.UL.ROW        Upper left  row           1 to 25
'       W.UL.COL        Upper left  column        1 to 80
'       W.LR.ROW        Lower right row           W.UL.ROW to 25
'       W.LR.COL        Lower right column        W.UL.COL to 80


window.partial.clear:
        w.ul.row=3 : w.ul.col=1 : w.lr.row=25 : w.lr.col=80 : GOSUB window.clear : RETURN

window.clear:
        window.func=6 : window.num.rows=0 : GOSUB window.routine : RETURN

window.up:
        window.func=6 : window.num.rows=1 : GOSUB window.routine : RETURN

window.down:
        window.func=7 : window.num.rows=1 : GOSUB window.routine : RETURN

window.routine:
        data.ok=true
        if w.lr.row<w.ul.row  or  w.lr.col<w.ul.col then data.ok=false
        if w.ul.row<1 or w.ul.row>25 or w.lr.row>25 then data.ok=false
        if w.ul.col<1 or w.ul.col>80 or w.lr.col>80 then data.ok=false
        if window.num.rows<>0 then if window.num.rows>w.lr.row-w.ul.row then data.ok=false
        if not data.ok then beep : RETURN


'                                       sets cleared area to black background...
        subrt.addr% = VARPTR(scroll(0))
        CALL ABSOLUTE (window.func,window.num.rows,w.ul.row,w.ul.col,w.lr.row,w.lr.col, subrt.addr% )
        RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
