'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $subtitle:      'CALLS.INC: Common Subroutine Calls'

'                       Screen control subroutines to clear from the cursor
'                       to the end of the line and to place the cursor
'                       at any row/column location on the screen.

'    Clear to end-of-line (set eol.row/col, and eol.fg/bg first)
clear.to.eol:
55000   saved.scroll.2 = scroll(2) : w.ul.row = eol.row : w.lr.row = eol.row : w.ul.col = eol.col : w.lr.col = 80
        if eol.fg=0 and eol.bg=0 then eol.fg=WHITE : eof.bg=BLACK
        MID$(init.scroll$,5,2) = HEX$(eol.bg)+HEX$(eol.fg) : scroll(2) = VAL(init.scroll$) : GOSUB window.clear
55005   scroll(2) = saved.scroll.2
55006   COLOR eol.fg,eol.bg
55007   LOCATE eol.row,eol.col : RETURN



'               Move cursor to beginning of previous line
cursor.up:
55017   locate csrlin-1,1 : RETURN


make.upper:
55020   for i=1 to len(entry$)
          if (mid$(entry$,i,1)>="a" and mid$(entry$,i,1)<="z") then mid$(entry$,i,1)=chr$(asc(mid$(entry$,i,1))-32)
        next i
55029   RETURN


center.line:
55030   start.col = ((80-len(entry$))\2)+1 : RETURN


'               Strip leading and trailing spaces from entry$
strip.blanks:
55040   if entry$="" then RETURN
        if entry$=space$(len(entry$)) then entry$="" : RETURN
        while left$(entry$,1)=" "
          if entry$=" " then entry$="" else entry$=mid$(entry$,2)
        wend
        if entry$="" then RETURN
55050   x=instr(entry$," ")
        if x=0 then return
        while right$(entry$,1)=" "
          if entry$=" " then entry$="" else entry$=left$(entry$,len(entry$)-1)
        wend
55059   RETURN


flush.keyboard:
55060   while inkey$ <> "" : wend : RETURN


'               Various kinds of sounds

sound.severe.error:
55100   if sound.sys then for j=1 to 2 : for i=1 to 2 : sound 200*i,1 : next i : sound 450,6 : sound 800,4 : next j else beep
55110   gosub flush.keyboard : RETURN

sound.minor.error:
55200   if sound.sys then for i=1 to 3 : sound 100*i,3 : next i else beep
55210   RETURN

sound.prompt:
55300   if sound.sys then for i=1 to 2 : sound 1000*i,1 : next i else beep
55310   RETURN

sound.success:
55400   if sound.sys then for i=1 to 2 : sound 500*i,3 : next i : sound 550,5  : sound 800,3 else beep
55410   RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
