'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $subtitle:  'MESSAGE.INC: Produce Various Types of Message on the Screen'


'       General message routines to display messages at the bottom
'       of the screen.  All messages must be in variable MSG$.


error.message:
        IF msg$<>"" THEN IF LEN(msg$)>79 THEN msg$=LEFT$(msg$,79)
        GOSUB sound.minor.error: eol.fg=scr.fg.emsg: eol.bg=scr.bg.emsg: GOSUB clear.btm: LOCATE ,2
        PRINT msg$;: COLOR scr.fg,scr.bg: msg$="": error.found=true: ch$=""
        WHILE ch$=""
            IF sound.sys THEN SOUND 1400,1 ELSE BEEP
            delay.seconds=5: GOSUB delay.sub
        WEND
        GOSUB clear.25: RETURN


warning.message:
        IF msg$<>"" THEN IF LEN(msg$)>79 THEN msg$=LEFT$(msg$,79)
        GOSUB sound.minor.error: eol.fg=scr.fg.wmsg: eol.bg=scr.bg.wmsg: GOSUB clear.btm: LOCATE ,2
        PRINT msg$;: COLOR scr.fg,scr.bg: msg$="": delay.seconds=7: GOSUB delay.sub: RETURN


status.message:
        IF msg$<>"" THEN IF LEN(msg$)>79 THEN msg$=LEFT$(msg$,79)
        eol.fg=scr.fg.smsg: eol.bg=scr.bg.smsg: GOSUB clear.btm: LOCATE ,2
        PRINT msg$;: COLOR scr.fg,scr.bg: msg$="": RETURN


wait.message:
        eol.fg=scr.fg.xmsg: eol.bg=scr.bg.xmsg: GOSUB clear.btm: LOCATE ,2
        PRINT "Wait please...";: COLOR scr.fg,scr.bg: LOCATE 1,1: RETURN


hold.message:
        eol.fg=scr.fg.hmsg: eol.bg=scr.bg.hmsg: GOSUB clear.btm: LOCATE ,2
        PRINT "Press "+xcr$+" to continue, or [Esc] to go back...";: GOSUB get.cr.esc
        GOSUB clear.25: RETURN


'       Clear row 25 - user sets eol.fg/bg
clear.btm:
        eol.row=25 : eol.col=1 : GOSUB clear.to.eol : RETURN


'       Clear row 25 - normal fg/bg
clear.25:
        eol.row=25 : GOSUB clear.a.line : RETURN


'       Clear row 24
clear.24:
        eol.row=24 : GOSUB clear.a.line : RETURN


'       Clear any line with normal screen attributes.  User must set EOL.ROW
clear.a.line:
        eol.col=1 : eol.fg=scr.fg : eol.bg=scr.bg : GOSUB clear.to.eol : RETURN


'       Accept input from the keyboard and ignore all but [RETURN] and [ESCAPE]
get.cr.esc:
        IF do.flush THEN GOSUB flush.keyboard
        escape=false: esc=0: ch$=""
gce.repeat:
        ch$=INKEY$: IF ch$=CHR$(16) THEN GOSUB input.scr.to.disk: ch$=""  'Control-P
        IF NOT (ch$=cr$ OR ch$=esc$) THEN GOTO gce.repeat
        IF ch$=esc$ THEN escape=true: esc=1
        RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
