'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'       $SUBTITLE:  'PATHS.INC: Find paths for certain data files'

'       Find data file paths in the DOS environment.
'       Use the DOS "SET" command to establish these paths.
'       Only one directory is assumed: all characters following a ";" are
'       eliminated.

        ENTRY$ = ENVIRON$("HLP"): GOSUB MAKE.UPPER   ' Directory for .HLP files
        IF ENTRY$<>"" THEN IF RIGHT$(ENTRY$,1)<>"\" THEN ENTRY$=ENTRY$+"\"
        PATH.HLP$ = ENTRY$

        ENTRY$ = ENVIRON$("CONFIG"): GOSUB MAKE.UPPER 'Directory for .CFG files
        IF ENTRY$<>"" THEN IF RIGHT$(ENTRY$,1)<>"\" THEN ENTRY$=ENTRY$+"\"
        PATH.CFG$ = ENTRY$

        ENTRY$ = ENVIRON$("DPATH"): GOSUB MAKE.UPPER ' Directory for data files
        IF ENTRY$<>"" THEN IF RIGHT$(ENTRY$,1)<>"\" THEN ENTRY$=ENTRY$+"\"
        PATH.DAT$ = ENTRY$

'       Find the current directory.

        SHELL "CD >$$$$$$$$.TMP"
        OPEN  "$$$$$$$$.TMP" FOR INPUT AS #1
        LINE  INPUT #1, ENTRY$
        CLOSE 1
        KILL  "$$$$$$$$.TMP"
        GOSUB MAKE.UPPER : CURR.DIR$=ENTRY$ : CHDIR CURR.DIR$
        CURR.DRIVE$ = LEFT$(CURR.DIR$,2)
        CURR.PATH$  = MID$(CURR.DIR$,3)
        IF CURR.PATH$<>"" THEN _
          IF LEFT$(CURR.PATH$,1)<>"\" THEN CURR.PATH$="\"+CURR.PATH$
        IF CURR.PATH$<>"" THEN _
          IF RIGHT$(CURR.PATH$,1)<>"\" THEN CURR.PATH$=CURR.PATH$+"\"
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
