'       Copyright 1981-1996 by Gerry J. Danen; all rights reserved.

'<t>    Show the directory on the screen


'       This file may be distributed freely, as long as no money is charged
'       for it, and all files are included AS THEY ARE!
'
'       Since you're not paying for the source code, don't expect support.
'       (Unless you're willing to pay for that of course!)


'       DIREC.MODE controls whether a file can be selected for processing:
'                      0 = no selection
'                      1 = selection of only one file possible
'                      2 = selection of one or more files possible
'       DIREC.TEXT$ contains instructions to be displayed


SHOW.DIR:
        IF DIR.NO.FILES<1 THEN DIREC.ENTRY$(1)="*** no files found ***": DIR.NO.FILES=1: DIREC.MODE=0
        CTRL.C=3:     CTRL.BREAK=-3: ESCAPE.KEY=27: HOME.KEY=-71: END.KEY=-79
        PG.UP=-73:    PG.DN=-81:     UP.KEY=-72:    DOWN.KEY=-80
        LEFT.KEY=-75: RIGHT.KEY=-77: CTRL.P=16 : ARROW$=CHR$(17)+""
        DIREC.SELECTED=FALSE: QUIT.IT=FALSE
        SD.INSTR$="  Use "+CHR$(25)+" "+CHR$(24)+" [Home] [End] [PgUp] [PgDn] to Move.   [Esc] to Quit.  "
        IF DIREC.MODE>0 THEN SD.INSTR$=SD.INSTR$+"S to Select."
        SD.INSTR$  =LEFT$((SD.INSTR$  +STRING$(80," ")),78)
        DIREC.TEXT$=LEFT$("  "+DIREC.TEXT$+STRING$(80," "),78)
        FIRST.SCRN=TRUE: GOSUB NEW.SCREEN: SD.MAX.LINES=16: SD.CURRENT=-9
        IF COLOR.SCREEN THEN _
          SD.COLR.1=WHITE: SD.COLR.2=YELLOW: SD.COLR.3=LT.CYAN: SD.COLR.BG=RED _
        ELSE _
          SD.COLR.1=WHITE: SD.COLR.2=HI.WHITE: SD.COLR.3=HI.WHITE: SD.COLR.BG=BLACK
        Z.FG.COLOR=SD.COLR.2: Z.BG.COLOR=SD.COLR.BG
        Z.UPP.ROW=3: Z.BOT.ROW=24: Z.UPP.COL=1: Z.BOT.COL=80: GOSUB MAKE.A.BOX
        COLOR SD.COLR.2,SD.COLR.BG: LOCATE 5,1: PRINT CHR$(199)+STRING$(78,196)+CHR$(182);
        COLOR SD.COLR.3,SD.COLR.BG: ENTRY$= LINE.B$ : GOSUB CENTER.LINE : LOCATE  5,START.COL : PRINT ENTRY$;
        LOCATE 4,2: PRINT LINE.A$: LOCATE 23,2: PRINT SD.INSTR$
        LOCATE 6,2: PRINT DIREC.TEXT$
        GOSUB SDIR.HOME
SDIR.REPEAT:
        GOSUB SDIR.GET.A.KEY
        IF QUIT.IT     THEN GOTO  SDIR.QUIT
        IF CH=HOME.KEY THEN GOSUB SDIR.HOME
        IF CH=END.KEY  THEN GOSUB SDIR.END
        IF CH=PG.UP    THEN GOSUB SDIR.UP.PAGE
        IF CH=PG.DN    THEN GOSUB SDIR.DN.PAGE
        IF CH=UP.KEY   THEN GOSUB SDIR.UP.LINE
        IF CH=DOWN.KEY THEN GOSUB SDIR.DN.LINE
        IF CH=ASC("S") THEN GOSUB SDIR.SELECT
        IF NOT QUIT.IT THEN GOTO  SDIR.REPEAT
SDIR.QUIT:
        RETURN


SDIR.GET.A.KEY:
        CH=0
        WHILE CH=0
          CH$=""
          WHILE LEN(CH$)=0 : GOSUB PRINT.TIME : CH$=INKEY$ : WEND
          IF LEN(CH$)=2 THEN CH=-ASC(RIGHT$(CH$,1)) ELSE CH=ASC(CH$)
          IF CH>122 THEN CH=0
          IF CH>96  THEN CH=CH-32
          IF CH>90  THEN CH=0
          IF CH=CTRL.C OR CH=CTRL.BREAK THEN CH=ESCAPE.KEY
          IF CH=CTRL.P THEN GOSUB INPUT.SCR.TO.DISK: CH=0                'Control-P
          IF CH=LEFT.KEY  THEN CH=UP.KEY
          IF CH=RIGHT.KEY THEN CH=DOWN.KEY
          IF CH=ESCAPE.KEY THEN QUIT.IT=TRUE: RETURN
          IF CH=HOME.KEY   THEN RETURN
          IF CH=END.KEY    THEN RETURN
          IF CH=PG.UP      THEN RETURN
          IF CH=PG.DN      THEN RETURN
          IF CH=UP.KEY     THEN RETURN
          IF CH=DOWN.KEY   THEN RETURN
          IF DIREC.MODE>0  THEN _
            IF CH=ASC("S") THEN RETURN
          CH=0: IF SOUND.SYS THEN SOUND 600,1: SOUND 1800,1 ELSE BEEP
        WEND
        RETURN


SDIR.CLEAR.AREA:
        W.UL.ROW=7: W.UL.COL=2: W.LR.ROW=22: W.LR.COL=79: GOSUB WINDOW.CLEAR: RETURN


SDIR.HOME:
        IF SD.CURRENT=1 THEN RETURN
        GOSUB SDIR.CLEAR.AREA: SD.L=SD.MAX.LINES: IF DIR.NO.FILES<SD.L THEN SD.L=DIR.NO.FILES
        FOR X=1 TO SD.L
          LOCATE 6+X,4: COLOR SCR.FG,SCR.BG: PRINT DIREC.ENTRY$(X);
        NEXT X
        SD.TOP.OF.SCR=1: SD.CURRENT=1: SD.CURR.LINE=1: GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.END:
        IF SD.CURRENT=DIR.NO.FILES THEN RETURN
        GOSUB SDIR.CLEAR.AREA: SD.L=SD.MAX.LINES: IF DIR.NO.FILES<SD.L THEN SD.L=DIR.NO.FILES
        FOR X=1 TO SD.L
          LOCATE 6+X,4: COLOR SCR.FG,SCR.BG: PRINT DIREC.ENTRY$(DIR.NO.FILES-(SD.L-X));
        NEXT X
        SD.TOP.OF.SCR=DIR.NO.FILES-SD.L+1: SD.CURRENT=DIR.NO.FILES: SD.CURR.LINE=SD.L: GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.DN.PAGE:
        IF (SD.TOP.OF.SCR+SD.MAX.LINES-1) => DIR.NO.FILES THEN RETURN
        SD.CURRENT = SD.TOP.OF.SCR+SD.MAX.LINES
SDIR.DO.PAGE:
        GOSUB SDIR.CLEAR.AREA
        FOR X=1 TO SD.L
          Y=(SD.CURRENT+(X-1))
          IF Y<=DIR.NO.FILES THEN _
            LOCATE 6+X,4: COLOR SCR.FG,SCR.BG: PRINT DIREC.ENTRY$(Y);
        NEXT X
        SD.TOP.OF.SCR=SD.CURRENT: SD.CURR.LINE=1: GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.UP.PAGE:
        IF SD.CURRENT=1 THEN RETURN
        IF (SD.TOP.OF.SCR-SD.MAX.LINES) < 1 THEN _
          SD.CURRENT = 1 _
        ELSE _
          SD.CURRENT = SD.TOP.OF.SCR-SD.MAX.LINES
        GOSUB SDIR.DO.PAGE: RETURN


SDIR.DN.LINE:
        IF (SD.CURRENT+1) > DIR.NO.FILES THEN RETURN
        GOSUB SDIR.OLD.LINE: SD.CURRENT = SD.CURRENT+1
        IF (SD.CURR.LINE+1) > SD.MAX.LINES THEN _
          SD.TOP.OF.SCR=SD.TOP.OF.SCR+1: _
          W.UL.ROW=7: W.UL.COL=2: W.LR.ROW=22: W.LR.COL=79: GOSUB WINDOW.UP _
        ELSE _
          SD.CURR.LINE = SD.CURR.LINE+1
        GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.UP.LINE:
        IF (SD.CURRENT-1) < 1 THEN RETURN
        GOSUB SDIR.OLD.LINE: SD.CURRENT = SD.CURRENT-1
        IF (SD.CURR.LINE-1) < 1 THEN _
          SD.TOP.OF.SCR=SD.TOP.OF.SCR-1: _
          W.UL.ROW=7: W.UL.COL=2: W.LR.ROW=22: W.LR.COL=79: GOSUB WINDOW.DOWN _
        ELSE _
          SD.CURR.LINE = SD.CURR.LINE-1
        GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.SELECT:
        DIREC.SELEC(SD.CURRENT) = NOT DIREC.SELEC(SD.CURRENT)
        IF DIREC.SELEC(SD.CURRENT) THEN _
          MID$(DIREC.ENTRY$(SD.CURRENT),42,5) = ARROW$ : DIREC.SELECTED=TRUE _
        ELSE _
          MID$(DIREC.ENTRY$(SD.CURRENT),42,5) = "     "
        GOSUB SDIR.SHOW.LINE
        RETURN


SDIR.SHOW.LINE:
        SD.COLR.BORDER=GRAY: IF SD.CURRENT=1 THEN SD.COLR.BORDER=CYAN
        IF SD.CURRENT=DIR.NO.FILES THEN SD.COLR.BORDER=RED
        IF NOT COLOR.SCREEN THEN SD.COLR.BORDER=BLACK
        COLOR SCR.BG,SCR.FG,SD.COLR.BORDER
SDIR.DO.LINE:
        LOCATE 6+SD.CURR.LINE,2: PRINT LEFT$("  "+DIREC.ENTRY$(SD.CURRENT)+STRING$(80," "),78);
        IF LEFT$(DIREC.ENTRY$(SD.CURRENT),3)="***" THEN _
          MSG$="No files." ELSE MSG$="File"+STR$(SD.CURRENT)+" of"+STR$(DIR.NO.FILES)+"."
        GOSUB STATUS.MESSAGE: COLOR SCR.FG,SCR.BG: RETURN


SDIR.OLD.LINE:
        LOCATE 6+SD.CURR.LINE,2: COLOR SCR.FG,SCR.BG: GOSUB SDIR.DO.LINE: RETURN
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
